org.springframework.jmx.export

## Interface MBeanExportOperations

All Known Implementing Classes:
  AnnotationMBeanExporter, MBeanExporter

    public interface MBeanExportOperations

Interface that defines the set of MBean export operations that are intended to be accessed by application developers during application runtime.

This interface should be used to export application resources to JMX using Spring's management interface generation capabilties and, optionally, it's `ObjectName` generation capabilities.

Since:
  2.0
Author:
  Rob Harrop
See Also:
  `MBeanExporter`

### Method Summary

Methods
`ObjectName` `registerManagedResource(Object managedResource)` Register the supplied resource with JMX.
`void` `registerManagedResource(Object managedResource, ObjectName objectName)` Register the supplied resource with JMX.
`void` `unregisterManagedResource(ObjectName objectName)` Remove the specified MBean from the underlying MBeanServer registry.

### Method Detail

#### registerManagedResource

    ObjectName registerManagedResource(Object managedResource)
                                       throws MBeanExportException

Register the supplied resource with JMX. If the resource is not a valid MBean already, Spring will generate a management interface for it. The exact interface generated will depend on the implementation and its configuration. This call also generates an `ObjectName` for the managed resource and returns this to the caller.

Parameters:
  `managedResource` - the resource to expose via JMX
Returns:
  the `ObjectName` under which the resource was exposed
Throws:
  `MBeanExportException` - if Spring is unable to generate an `ObjectName` or register the MBean

#### registerManagedResource

    void registerManagedResource(Object managedResource,
                               ObjectName objectName)
                                 throws MBeanExportException

Register the supplied resource with JMX. If the resource is not a valid MBean already, Spring will generate a management interface for it. The exact interface generated will depend on the implementation and its configuration.

Parameters:
  `managedResource` - the resource to expose via JMX
  `objectName` - the `ObjectName` under which to expose the resource
Throws:
  `MBeanExportException` - if Spring is unable to register the MBean

#### unregisterManagedResource

    void unregisterManagedResource(ObjectName objectName)

Remove the specified MBean from the underlying MBeanServer registry.

Parameters:
  `objectName` - the `ObjectName` of the resource to remove